capt program drop spid
program define spid, eclass

version 12.0

/* This is a command that provides inference for bounds proposed by Kim et al (2013)
using the method proposed by Chernozhukov et al (2013). */ 

syntax varlist [if] [in] [, ASSUMption(string) T(real 0) B(real 0) *]

tokenize `varlist'

local y `1'
local s `2'
local v `3'
local rangel `4'
local rangeu `5'


if "`assumption'" == "str" {
	quietly gen spidl = `y' - `b' * abs(`s'-`t')
	quietly gen spidu = `y' + `b' * abs(`s'-`t')
	 
}
else if "`assumption'" == "smtr" {
	quietly gen spidl = `y' - `b' * max(`s'-`t',0)
	quietly gen spidu = `y' + `b' * max(`t'-`s',0)	
}


ereturn clear
	
clr3bound (( spidl `v' `rangel')) (( spidu `v' `rangeu')), `options'  		

ereturn local cmd = "spid"


drop spidl spidu

end
